LIBITEMDB_CACHE_VERSION = 8;
LIBITEMDB_USE_CACHE = false;
LIBITEMDB_CACHE_VARIABLE_LIST = {"gemIds","name","itemType","itemSubType","link","itemId","enchantId","suffixId","linkLevel" }

-- This based on RatingBuster
LIBITEMDB_NUMBER_PATTERN = {
	{pattern = " by (%d+)", addInfo = "AfterNumber",},
	{pattern = "([%+%-]%d+)[^%%]", addInfo = "AfterStat",},
	--{pattern = "grant.-(%d+)", addInfo = "AfterNumber",}, -- for "grant you xx stat" type pattern, ex: Quel'Serrar ID:18348, Assassination Armor set
	--{pattern = "add.-(%d+)", addInfo = "AfterNumber",}, -- for "add xx stat" type pattern, ex: Adamantite Sharpening Stone ID:23529
	-- Added [^%%] so that it doesn't match strings like "Increases healing by up to 10% of your total Intellect." [Whitemend Pants] ID:24261
	-- Added [^|] so that it doesn't match enchant strings (JewelTips)
	{pattern = "(%d+)([^%d%%|]+)", addInfo = "AfterStat",}, -- [發光的暗影卓奈石] +6法術傷害及5耐力
	{pattern = "(%d+%.%d+)", addInfo = "AfterStat"}
}
-- This is from RatingBuster
LIBITEMDB_SEPARATORS = {
	"/", " and ", ",", "%. ", " for ", "&", ":",
	-- Fix for [Mirror of Truth]
	-- Equip: Chance on melee and ranged critical strike to increase your attack power by 1000 for 10 secs.
	-- 1000 was falsely detected detected as ranged critical strike
	"increase your",
}

LIBITEMDB_REPLACEMENTS = {
	["%("]="",
	["%)"]="",
	["health and mana every 5 sec"]="mana per five sec",
	["per 5 sec"]= "per five sec",
	["every 5 sec"]="per five sec",
--	["+8 all stats"]= "+8 strength and +8 agility and +8 intellect and +8 spirit and +8 stamina",
--	["+10 all stats"]= "+10 strength and +10 agility and +10 intellect and +10 spirit and +10 stamina"
}

LIBITEMDB_ITEMTYPES = {
	[GetSpellInfo(5009)]="Wand",
	[GetSpellInfo(203)]="Unarmed",
	[GetSpellInfo(202)]="Two-Handed Sword",
	[GetSpellInfo(199)]="Two-Handed Mace",
	[GetSpellInfo(197)]="Two-Handed Axe",
	[GetSpellInfo(2567)]="Thrown",
	[GetSpellInfo(227)]="Stave",
	[GetSpellInfo(200)]="Polearm",
	[GetSpellInfo(201)]="One-Handed Sword",
	[GetSpellInfo(198)]="One-Handed Mace",
	[GetSpellInfo(196)]="One-Handed Axe",
	[GetSpellInfo(266)]="Gun",
	[GetSpellInfo(15590)]="Fist Weapon",
	[GetSpellInfo(1180)]="Dagger",
	[GetSpellInfo(5011)]="Crossbow",
	[GetSpellInfo(264)]="Bow",
}

LIBITEMDB_STATS_REPLACEMENTS = {
	["defense"] = "defense rating",
	
	["critical hit rating"] = "crit rating",
	["critical rating"] = "crit rating",
	["critical strike rating"] = "crit rating",
	["spell critical rating"]="crit rating",
	["spell crit rating"]="crit rating",
	["spell critical hit rating"]="crit rating",
	["ranged critical strike rating"]="crit rating",
	["ranged critical strike"]="crit rating",
	["ranged critical hit rating"]="crit rating",
	["ranged critical rating"]="crit rating",
	["ranged crit rating"]="crit rating",
	
	["speed rating"]="haste rating",

	["spell hit rating"]="hit rating",
	["ranged hit rating"]="hit rating",
	
	["spell haste rating"]="haste rating",
	["ranged haste rating"]="haste rating"
}

-- This is based on RatingBuster
LIBITEMDB_STATS_LIST = {
	str={pattern = string.lower(SPELL_STAT1_NAME), id = SPELL_STAT1_NAME}, -- Strength
	agi={pattern = string.lower(SPELL_STAT2_NAME), id = SPELL_STAT2_NAME}, -- Agility
	sta={pattern = string.lower(SPELL_STAT3_NAME), id = SPELL_STAT3_NAME}, -- Stamina
	int={pattern = string.lower(SPELL_STAT4_NAME), id = SPELL_STAT4_NAME}, -- Intellect
	spi={pattern = string.lower(SPELL_STAT5_NAME), id = SPELL_STAT5_NAME}, -- Spirit
	dps={pattern = "damage per second", id = DAMAGE_PER_SECOND, isWeaponOnly=true},
	speed={pattern = "speed", id = WEAPON_SPEED, isWeaponOnly=true},
	ap={pattern = "attack power", id = STAT_ATTACK_POWER},
	sp={pattern = "spell power", id = ITEM_MOD_SPELL_POWER},
	def={pattern = "defense rating", id = CR_DEFENSE_SKILL},
	dodge={pattern = "dodge rating", id = CR_DODGE},
	block={pattern = "block rating", id = CR_BLOCK}, -- block enchant: "+10 Shield Block Rating"
	parry={pattern = "parry rating", id = CR_PARRY},

--	{pattern = "spell critical strike rating", id = CR_CRIT_SPELL},
--	{pattern = "spell critical hit rating", id = CR_CRIT_SPELL},
--	{pattern = "spell critical rating", id = CR_CRIT_SPELL},
--	{pattern = "spell crit rating", id = CR_CRIT_SPELL},
--	{pattern = "ranged critical strike rating", id = CR_CRIT_RANGED},
--	{pattern = "ranged critical strike", id = CR_CRIT_RANGED}, -- [Heartseeker Scope]
--	{pattern = "ranged critical hit rating", id = CR_CRIT_RANGED},
--	{pattern = "ranged critical rating", id = CR_CRIT_RANGED},
--	{pattern = "ranged crit rating", id = CR_CRIT_RANGED},
	crit={pattern = "crit rating", id = CR_CRIT_MELEE},
--	{pattern = "critical hit rating", id = CR_CRIT_MELEE},
--	{pattern = "critical rating", id = CR_CRIT_MELEE},
--	{pattern = "crit rating", id = CR_CRIT_MELEE},

--	{pattern = "spell hit rating", id = CR_HIT_SPELL},
--	{pattern = "ranged hit rating", id = CR_HIT_RANGED},
	hit={pattern = "hit rating", id = CR_HIT_MELEE},

	resil={pattern = "resilience", id = CR_CRIT_TAKEN_MELEE}, -- resilience is implicitly a rating

--	{pattern = "spell haste rating", id = CR_HASTE_SPELL},
--	{pattern = "ranged haste rating", id = CR_HASTE_RANGED},
	haste={pattern = "haste rating", id = CR_HASTE_MELEE},
--	{pattern = "speed rating", id = CR_HASTE_MELEE}, -- [Drums of Battle]

	skill={pattern = "skill rating", id = CR_WEAPON_SKILL},
	exp={pattern = "expertise rating", id = CR_EXPERTISE},

	hitavoid={pattern = "hit avoidance rating", id = CR_HIT_TAKEN_MELEE},
	apen={pattern = "armor penetration rating", id = CR_ARMOR_PENETRATION},
	armor={pattern = string.lower(ARMOR), id = ARMOR},
	
	
	mp5={pattern = "mana per five sec", id = ITEM_MOD_MANA_REGENERATION},
--	{pattern = "health per five sec", id = ITEM_MOD_HEALTH_REGENERATION},
	--[[
	{pattern = "dagger skill rating", id = CR_WEAPON_SKILL},
	{pattern = "sword skill rating", id = CR_WEAPON_SKILL},
	{pattern = "two%-handed swords skill rating", id = CR_WEAPON_SKILL},
	{pattern = "axe skill rating", id = CR_WEAPON_SKILL},
	{pattern = "bow skill rating", id = CR_WEAPON_SKILL},
	{pattern = "crossbow skill rating", id = CR_WEAPON_SKILL},
	{pattern = "gun skill rating", id = CR_WEAPON_SKILL},
	{pattern = "feral combat skill rating", id = CR_WEAPON_SKILL},
	{pattern = "mace skill rating", id = CR_WEAPON_SKILL},
	{pattern = "polearm skill rating", id = CR_WEAPON_SKILL},
	{pattern = "staff skill rating", id = CR_WEAPON_SKILL},
	{pattern = "two%-handed axes skill rating", id = CR_WEAPON_SKILL},
	{pattern = "two%-handed maces skill rating", id = CR_WEAPON_SKILL},
	{pattern = "fist weapons skill rating", id = CR_WEAPON_SKILL},
	--]]
}

LIBITEMDB_ITEM_TYPE_SKIPPABLES = {
	"Unique", "Unique-Equipped", "Soulbound",
	"Binds to account", "Binds when picked up", "Binds when equipped"
}

LIBITEMDB_TOOLTIP_ANCHOR = "ANCHOR_NONE"

LIBITEMDB_DEBUG = true;
LIBITEMDB_DEBUG_ANCHOR = false;

LibItemDB = {};
LibItemDB.cache = {};
LibItemDB.cache.items = {};
LibItemDB.cache.enchants = {};
LibItemDB.cache.gems = {};

LIBITEMDB_ENCHANT_PARSE_ITEM = "item:43586:0:0:0:0:0:0:0:0";
LIBITEMDB_ENCHANT_PARSE_ITEM_DATA = nil

function LibItemDB.Debug(msg) 
	if (LIBITEMDB_DEBUG) then
		if (strfind(msg, '\n') ~= nil) then
			for _, line in ipairs({strsplit('\n', msg)}) do
				DEFAULT_CHAT_FRAME:AddMessage(line);
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage(msg);
		end
	end
end

function LibItemDB.Init()
	if (LIBITEMDB_DEBUG_ANCHOR) then
		LIBITEMDB_TOOLTIP_ANCHOR = "ANCHOR_TOPLEFT"
	end

	-- Create hidden tooltips
	-- IF TOOLTIP INHERITS FROM GameTooltipTemplate, LINE 9 IS ALWAY nil
	-- IF TOOLTIP DOES NOT INHERIT FROM GameTooltipTemplate, CANNOT LOAD ITEM NOT IN LOCAL CACHE
	-- So we use two tooltip
	LibItemDB.hiddenTooltip = CreateFrame("GAMETOOLTIP", "LibItemDBTooltip", nil);
	LibItemDB.hiddenTooltip:SetOwner( UIParent, LIBITEMDB_TOOLTIP_ANCHOR );
	LibItemDB.hiddenTooltip:AddFontStrings(
			LibItemDB.hiddenTooltip:CreateFontString( "$parentTextLeft1", nil, "GameTooltipText" ),
			LibItemDB.hiddenTooltip:CreateFontString( "$parentTextRight1", nil, "GameTooltipText" )
	);

	LibItemDB.hiddenLoaderTooltip = CreateFrame("GAMETOOLTIP", "LibItemDBLoaderTooltip", nil, "GameTooltipTemplate");
	LibItemDB.hiddenLoaderTooltip:SetOwner( UIParent, LIBITEMDB_TOOLTIP_ANCHOR );
	LibItemDB.hiddenLoaderTooltip:AddFontStrings(
			LibItemDB.hiddenLoaderTooltip:CreateFontString( "$parentTextLeft1", nil, "GameTooltipText" ),
			LibItemDB.hiddenLoaderTooltip:CreateFontString( "$parentTextRight1", nil, "GameTooltipText" )
	);
	
	LibItemDB.hiddenTooltip:RegisterEvent("PLAYER_LOGIN");
	LibItemDB.hiddenTooltip:HookScript("OnEvent", function(self, event, ...)
		if (event == "PLAYER_LOGIN") then
			LIBITEMDB_ENCHANT_PARSE_ITEM_LINES = LibItemDB.GetTooltipText(LIBITEMDB_ENCHANT_PARSE_ITEM);
			LibItemDB.FillInLibItemDbItemStringSpecial()
		end
	end)
end

function LibItemDB.FillInLibItemDbItemStringSpecial()
	LIBITEMDB_ITEMSTRINGS_SPECIAL_PARSED = {}
	local item = LIBITEMDB_ENCHANT_PARSE_ITEM;
	local itemParts = {LibItemDB.SplitItemString(item)};
	local isRed = false;
	local isYellow = false;
	local isBlue = false;
	local isMeta = false;
	local lines, line
	local pattern = gsub(ITEM_MOD_STRENGTH, SPELL_STAT1_NAME, '%%s')
	pattern = LIBITEMDB_ITEMSTRINGS_FixGlobalString(pattern)
	for i, table in ipairs(LIBITEMDB_ITEMSTRINGS_SPECIAL) do
		local tableParsed = {table[1], table[2], false};
		if (type(table[2]) == 'number') then
			itemParts[2] = table[2];
			itemEnchanted = strjoin(":", "item", unpack(itemParts));
			lines = LibItemDB.GetTooltipText(itemEnchanted)
			for i=1,#lines do
				if (lines[i] ~= LIBITEMDB_ENCHANT_PARSE_ITEM_LINES[i]) then
					line = lines[i];
					break
				end
			end
			local sign, number, stat = strmatch(line, pattern);
			tableParsed[2] = gsub(ITEM_MOD_STRENGTH, SPELL_STAT1_NAME, strlower(stat));
		end
		tableParsed[2] = LIBITEMDB_ITEMSTRINGS_FixGlobalString(tableParsed[2]);
		local tableParsedSpecial = {table[1], tableParsed[2], tableParsed[3]};
		tableParsedSpecial[2] = strsub(tableParsedSpecial[2], 2, strlen(tableParsedSpecial[2])-1)
		tinsert(LIBITEMDB_ITEMSTRINGS_SPECIAL_PARSED, tableParsedSpecial);
	end
end

function LibItemDB.SetTooltipHyperlink(tooltip, link) 
	assert(link ~= nil)
	local success, errorMsg = pcall(tooltip.SetHyperlink, tooltip, link);
	if not success then LibItemDB.Debug(errorMsg) end
	if (tooltip:GetOwner() == nil) then
		tooltip:SetOwner( UIParent, LIBITEMDB_TOOLTIP_ANCHOR );
		success, errorMsg = pcall(tooltip.SetHyperlink, tooltip, link);
		if not success then LibItemDB.Debug(errorMsg) end
	end
end


function LibItemDB.GetItemData(link)
	local result = LibItemDB.cache.items[link]
	if (result == nil) then
		result = LibItemDB.ParseItem(link, true);
		LibItemDB.cache.items[link] = result;
	end
	return result;
end

function LibItemDB.GetGemData(gemId)
	local result = LibItemDB.cache.gems[gemId]
	if (not result) then		
		result = LibItemDB.ProcessUnknownEnchant(gemId, true) 
		result["GEM_COLORS"] = {LibItemDB.GetGemColor(gemId)}
		LibItemDB.cache.gems[gemId] = result;		
	end
	return result;
end

function LibItemDB.GetEnchantData(enchantId)
	local result = LibItemDB.cache.enchants[enchantId]
	if (not result) then
		result = LibItemDB.ProcessUnknownEnchant(enchantId) 
		LibItemDB.cache.enchants[enchantId] = result;		
	end
	return result 
end

function LibItemDB.ProcessUnknownEnchant(enchantId, isGem) 
--	if (LIBITEMDB_ENCHANTID[enchantId]) then return end;
	local result = nil;
	local item = LIBITEMDB_ENCHANT_PARSE_ITEM;
	local base = LIBITEMDB_ENCHANT_PARSE_ITEM_LINES;
	local itemParts = {LibItemDB.SplitItemString(item)};
	if (isGem) then
		itemParts[3]  = enchantId
	else
		itemParts[2]  = enchantId
	end
	item = strjoin(":", "item", unpack(itemParts))
	local lines = LibItemDB.GetTooltipText(item)
	local enchantText = nil;
	for i=1,#lines do
		if (lines[i] ~= LIBITEMDB_ENCHANT_PARSE_ITEM_LINES[i]) then
			enchantText = lines[i]
			break
		end
	end
	if (enchantText ~= nil) then
	    enchantText = gsub(enchantText, "|cffffffff", '');
		enchantText = gsub(enchantText, "|r", '');
		--Spew("enchantText", enchantText)
	--	LIBITEMDB_ENCHANTID[enchantId] = LibItemDB.ParseTextMultiple(enchantText, true);
		result = LibItemDB.ParseTextMultiple(enchantText, true)
	end
	if (not (result and pairs(result)(result))) then result = {TEXT=enchantText} end;
	return result;
end

function LibItemDB.GetGemColor(gemId) 
	local staticGems = {red=3448, yellow=3458, blue=3454, meta=3623}
	local tooltip = LibItemDBLoaderTooltip
	local itemParts = {LibItemDB.SplitItemString("item:43586:0:0:0:0:0:0:0:0")}; -- Item with red, yellow, blue
	local result = {};
	local baseColor = nil;
	for i=2,6 do
		if (i ~= 6) then
			itemParts[3] = i == 3 and gemId or staticGems.red;
			itemParts[4] = i == 4 and gemId or staticGems.yellow;
			itemParts[5] = i == 5 and gemId or staticGems.blue;
		else 
			itemParts = {LibItemDB.SplitItemString("item:28183:0:0:0:0:0:0:0:0")}; -- Item with blue and meta
			itemParts[2] = 1 -- Push gem bonus down so it isn't nil
			itemParts[3] = staticGems.blue;
			itemParts[4] = gemId;
		end
		itemGemmed = strjoin(":", "item", unpack(itemParts));
		LibItemDB.SetTooltipHyperlink(tooltip, itemGemmed);
		if (i == 2) then
			baseColor = _G[ tooltip:GetName().."TextLeft"..10]:GetTextColor(); -- Active bonus color
		else
			result[i] = _G[ tooltip:GetName().."TextLeft"..10]:GetTextColor() == baseColor
		end
	end
	
	return result[3], result[4], result[5], result[6] -- isRed, isYellow, isBlue, isMeta
end

function LibItemDB.LoadItemData(link)
	return LibItemDB.ParseItem(link, true)
--	LibItemDB.SetTooltipHyperlink(LibItemDB.hiddenLoaderTooltip, link);
--	LibItemDB.SetTooltipHyperlink(LibItemDB.hiddenTooltip, link);
--	return LibItemDB.ProcessTooltip(LibItemDB.hiddenTooltip, "", link)
end

--[[
-- This is based - loosely - on RatingBuster
function LibItemDB.ProcessTooltip(tooltip, name, link)
--	Print("Processing: "..link);
	local result = {};
	local itemString, itemId, enchantId, gem1Id, gem2Id, gem3Id, gem4Id, suffixId, uniqueId, linkLevel = LibItemDB.SplitLink(link);

	-- Loop through tooltip lines starting at line 2
	local tipTextLeft = tooltip:GetName().."TextLeft"
	local tipTextRight = tooltip:GetName().."TextRight"
	if (tooltip:NumLines() < 1) then return nil end;
	local itemName = _G[tipTextLeft..'1']:GetText();
	local itemType = nil;
	local itemSubType = nil;
	for i=1, tooltip:NumLines() do
		if (_G[tipTextRight..i] and _G[tipTextRight..i]:GetText()) then
			itemSubType = _G[tipTextRight..i]:GetText()
			itemType = _G[tipTextLeft..i]:GetText()
			break;
		end
	end
	if (itemType == nil) then
		for i=2,4 do
			if (_G[tipTextLeft..i] and _G[tipTextLeft..i]:GetText()) then
				local text = _G[tipTextLeft..i]:GetText()
				local skip = false
				for _, skipable in pairs(LIBITEMDB_ITEM_TYPE_SKIPPABLES) do
					if (text == skipable) then
						skip = true;
						break;
					end
				end
				if (not skip) then
					itemType = text;
					break;
				end
			end
		end
	end
	local uniqueId = itemString -- strjoin(':', itemId, gem4Id, gem4Id, gem4Id, gem4Id)
	-- Check cache...
--	if (tooltip:NumLines() == 1 or _G[tipTextLeft..'2'] == 'BOA') then
--		uniqueId = strjoin(':', uniqueId, linkLevel)
--	end
	--Print('Processing: '..link);
	local rawStats = {};
	local i;
	for i = 2, tooltip:NumLines() do
		local fontString = _G[tipTextLeft..i]
		local text = string.lower(fontString:GetText())
		--Print(text);
		-- Replace variants with standard version, do workarrounds for some stats
		for pattern, replacement in pairs(LIBITEMDB_REPLACEMENTS) do
			--Print(pattern)
			if strfind(text, pattern) then
				text = gsub(text, pattern, replacement)
			end
		end
		local colorR, colorG, colorB, _ = fontString:GetTextColor();
		if (strfind(text, "use:") ~= nil or strfind(text, "chance") ~= nil) then
			 -- Ignore on use/chance effects
		elseif (strfind(text, "socket bonus") ~= nil and colorR==colorG and colorR==colorB) then
			 -- Grey text on socket bonus == disabled bonus
		elseif text and strfind(text, "%d") then -- do nothing if we don't find a number
			LibItemDB.ProcessText(text, rawStats)
		end
	end
	
	for i = 1, tooltip:NumLines() do
		local fontString = _G[tipTextRight..i]
		if fontString then
			local text = fontString:GetText()
			if text and strfind(text, "%d") then -- do nothing if we don't find a number
				LibItemDB.ProcessText(string.lower(text), rawStats)
			end
		end
	end
	local isWeapon = false
	local weaponStats = {}
	local stats = {}
	--Spew("rawStats", rawStats)
	-- Total up all stats
	for i = 1, #rawStats do
		local stat = rawStats[i].stat;
		local value = rawStats[i].value;
		if (rawStats[i].isWeaponOnly) then
			weaponStats[stat] = value;
			isWeapon = true;
		else
			if (stats[stat] ~= nil) then
				value = value + stats[stat];
			end
			stats[stat] = value;
		end
	end
	result.gemIds = {}
	result.name = itemName;
	result.itemType = itemType;
	result.itemSubType = itemSubType;
	result.link = link;
	result.isWeapon = isWeapon;
	result.stats = stats;
	result.weaponStats = weaponStats;
	result.itemId = tonumber(itemId);
	result.enchantId = tonumber(enchantId)
	result.gemIds[1] = tonumber(gem1Id)
	result.gemIds[2] = tonumber(gem2Id)
	result.gemIds[3] = tonumber(gem3Id)
	result.gemIds[4] = tonumber(gem4Id)
	result.suffixId = tonumber(suffixId)
	result.linkLevel = tonumber(linkLevel)
	--Spew(link, result);
	return result;
end

-- This is loosely based on RatingBuster
function LibItemDB.ProcessText(text, finalResult)
	--Spew("text", text)
	for _, sep in ipairs(LIBITEMDB_SEPARATORS) do
		if strfind(text, sep) then
			text =  gsub(text, sep, "@")
		end
	end
	local textParts = {strsplit("@", text)}
	for j = 1, #textParts do
		local result = nil;
		-- Convert text to lower so we don't have to worry about same ratings with different cases
		local lowerText = string.lower(textParts[j])
		--Spew("lowerText", lowerText)
		-- Check if test has a matching pattern
		for _, num in ipairs(LIBITEMDB_NUMBER_PATTERN) do
			result = nil;
			-- Capture the stat value
			local s, e, value, partialtext = strfind(lowerText, num.pattern)
			--Spew("num.pattern", num.pattern)
			--Spew("partialtext", partialtext)
			if value then
				--Spew("value", value)
				if partialtext and tonumber(partialtext) then
					value, partialtext = partialtext, value
				end
				--Spew("partialtext", partialtext)
				
				-- Capture the stat name
				for name, stat in pairs(LIBITEMDB_STATS_LIST) do
					if (not partialtext and strfind(lowerText, stat.pattern)) or (partialtext and strfind(partialtext, stat.pattern)) then
						--Spew(name, stat);
						result = {["stat"]=name, ["value"]=tonumber(value), ["isWeaponOnly"]=(stat.isWeaponOnly ~= nil)}
						break;
					end
				end
				
				if (result == nil) then
					-- Check for variants
					for pattern, statVariant in pairs(LIBITEMDB_STATS_REPLACEMENTS) do
						if (not partialtext and strfind(lowerText, pattern)) or (partialtext and strfind(partialtext, pattern)) then
							-- Convert variants to standard names
							for name, stat in pairs(LIBITEMDB_STATS_LIST) do
								if (stat.pattern == statVariant) then
									--Spew(name, stat);
									result = {["stat"]=name, ["value"]=tonumber(value), ["isWeaponOnly"]=(stat.isWeaponOnly ~= nil)}
									break;
								end
							end
						end
						if (result ~= nil) then break end
					end
				end
			end
			--Spew(partialtext or "nil", result);
			if (result ~= nil) then 
				tinsert(finalResult, result)
				break;
			end
		end
	end
	return nil;
end
]]
function LibItemDB.SplitLink(link) 
	local itemString = LibItemDB.LinkToItemString(link) 
	return itemString, LibItemDB.SplitItemString(itemString)
end

function LibItemDB.LinkToItemString(link) 
	local found, _, itemString = string.find(link, "^|c%x+|H(.+)|h%[.*%]")
	if (found) then return itemString 
	else return nil end;
end

function LibItemDB.SplitItemString(itemString) 
	local parts = {strsplit(":", itemString)}
	if (#parts ~= 10) then return nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil end;
	local num = tonumber;
	return num(parts[2]), num(parts[3]), num(parts[4]), num(parts[5]), num(parts[6]), num(parts[7]), num(parts[8]), num(parts[9]), num(parts[10])
end


function LibItemDB.RemoveEnchantsFromItemString(link)
	local linkParts = {LibItemDB.SplitItemString(link)}
	linkParts[2] = 0;
	linkParts[3] = 0;
	linkParts[4] = 0;
	linkParts[5] = 0;
	linkParts[6] = 0;
	return strjoin(":", "item", unpack(linkParts))
end
	
function LibItemDB.ParseItem(link, clean)
	local result = {}
	local tooltip = LibItemDBTooltip
	local itemString = LibItemDB.LinkToItemString(link);
	if (itemString == nil) then itemString = link; end;
	local itemParts = {LibItemDB.SplitItemString(itemString)};
	local lines = nil;
	if (clean) then
		lines = LibItemDB.GetTooltipText(LibItemDB.RemoveEnchantsFromItemString(itemString));
	else
		lines = LibItemDB.GetTooltipText(itemString);
	end
	assert(lines ~= nil)
	local count = {}
	local inSetList = false;
	for i=2, #lines do
		local value, name;
		local text = lines[i];
		local found = false;
	 	local textTrimmed = strtrim(text);
	 	if (textTrimmed ~= "") then
	 		name, value = LibItemDB.ParseText(textTrimmed)
			if (name == nil) then
				if (inSetList) then	   
					name = "ITEM_SET_LIST";
					value = textTrimmed;
				else
					name = "UNKNOWN_TEXT";
					value = text;
		  		end
			end
			if (strsub(name, 0, 12) == 'EMPTY_SOCKET') then
				value = strsub(name, 14)
				name = 'EMPTY_SOCKET';
			end 
		 	inSetList = name == "ITEM_SET_LIST" or name == "ITEM_SET_NAME";
			if (result[name] ~= nil) then
				if (count[name] == 1) then
					result[name] = {result[name], value}
					count[name] = 2;
					result[name].array = true;
				else
					tinsert(result[name], value)
				end
			else
				result[name] = value;
				count[name] = 1;
			end
		end
		--		Print(i..": ["..text..']')
		if (_G[ tooltip:GetName().."TextRight"..i]) then
			local text = _G[ tooltip:GetName().."TextRight"..i]:GetText();
			if (text and strfind(text, WEAPON_SPEED) ~= nil) then
				result["WEAPON_SPEED"] = tonumber(strmatch(text, '%d+%.?%d*'))
			end
		end
	end
	if (clean) then
		--Spew("itemParts", itemParts)
--		if (result["EMPTY_SOCKET_BLUE"] or result["EMPTY_SOCKET_RED"] or result["EMPTY_SOCKET_YELLOW"] or result["EMPTY_SOCKET_META"]) then
			local socketBonus = true;
			local sockets = {}
			local socketColors = {"RED", "YELLOW", "BLUE", "META"}
			if (result['EMPTY_SOCKET']) then
				if (result['EMPTY_SOCKET'].array) then
					for _, color in ipairs(result['EMPTY_SOCKET']) do
						for index, socketColor in ipairs(socketColors) do
							if (socketColor == color) then
								tinsert(sockets, index)
								break
							end
						end
					end
				else
					for index, socketColor in ipairs(socketColors) do
						if (socketColor == result['EMPTY_SOCKET']) then
							tinsert(sockets, index)
							break
						end
					end
				end
			end
			--Spew("itemParts", itemParts)
			--Spew("sockets", sockets)
			--Spew("#sockets", #sockets)
			result["GEMS"] = {}
			for i=1,4 do
				if (itemParts[i+2] == 0) then
					socketBonus = socketBonus and (i > #sockets);
				else
					result["GEMS"][i] = itemParts[i+2];
					local gem = LibItemDB.GetGemData(itemParts[i+2]);
					if (not gem["GEM_COLORS"][sockets[i]]) then
						socketBonus = false
					end
				end
			end
			if (not socketBonus and result["ITEM_SOCKET_BONUS"]) then
				result["ITEM_SOCKET_BONUS_GREY"] = result["ITEM_SOCKET_BONUS"];
				result["ITEM_SOCKET_BONUS"] = nil;
			end
--		end
		if (itemParts[2] ~= 0) then
			result["ENCHANT"] = itemParts[2];
		end
	end
	result['INFO'] = {GetItemInfo(link)}
	return result;
--	Spew("result", result)
end

function LibItemDB.GetTooltipText(itemString) 
	local lines = {};
	LibItemDB.SetTooltipHyperlink(LibItemDBLoaderTooltip, itemString);
	LibItemDB.SetTooltipHyperlink(LibItemDBTooltip, itemString);

	for i=2, LibItemDBTooltip:NumLines() do
		local line = _G[LibItemDBTooltip:GetName().."TextLeft"..i];
		if (line) then
			local text = line:GetText();
			if (text) then
				tinsert(lines, text);
			end
		end
	end
	return lines;

end

function LibItemDB.ParseTextMultiple(text, special)
	local index = nil;
	local result = {}
	local name, value, index = LibItemDB.ParseText(text, special)
	--Spew(text, index);
	while name ~= nil do
		result[name] = value
		name, value, index = LibItemDB.ParseText(text, special, index+1)
	end
	return result;
end

function LibItemDB.ParseText(text, special, index)
	if (index == nil) then index = 1 end
	local name = nil
	local value = nil
	local patterns = LIBITEMDB_ITEMSTRINGS_PARSED;
	if (special) then
		patterns = LIBITEMDB_ITEMSTRINGS_SPECIAL_PARSED
		text = strlower(text)
	end
	for i=index,#patterns do
		local table = patterns[i];
		local matches = {strmatch(text, table[2])};
--		Spew('matches', matches)
		if (#matches ~= 0) then
			found = true;
			name = table[1]
			if (table[3]) then
				if (name == 'ITEM_SOCKET_BONUS' or name == 'ITEM_SET_BONUS') then
					--Spew("text", {text})
					--Spew("matches", matches)
					--Spew("name", {name})
					value = LibItemDB.ParseTextMultiple(matches[#matches], name == 'ITEM_SOCKET_BONUS')
					--Spew("value", value)
					if (pairs(value)(value) == nil) then value = matches end
					if (#value == 1) then value = value[1] end
					--Spew("value", {value})
				else
					innerName, innerValue = LibItemDB.ParseText(matches[#matches], innerSpecial)
					if innerName then
						if (name == 'ITEM_SPELL_TRIGGER_ONEQUIP') then
							name = innerName;
							value = innerValue;
						else 
							matches[#matches] = {innerName, innerValue}
							if (#matches == 1) then matches = matches[1] end
							value = matches
						end
					else 
						if (#matches == 1) then matches = matches[1] end
						value = matches
					end
				end
			else
				for index, value in pairs(matches) do
					if (strtrim(value) == '') then
						tremove(matches, index)
					else
						local valueAsNumber = tonumber(value)
						if (valueAsNumber ~= nil) then matches[index] = valueAsNumber end
					end
				end
				if (#matches == 2 and (matches[1] == '-' or matches[1] == '+')) then
					if (matches[1] == '-') then emp[2] = -matches[2] end
					matches = {matches[2]}
				end
				if (#matches == 1) then matches = matches[1] end
				value = matches;
				-- Spew(text..'-'..pattern, strmatch(textWithoutEquip, pattern))
			end
			return name, value, i
		end
	end
end

function LibItemDB.TableToLuaString(table)
	return LibItemDB.tablelib.tostring( table );
end

LibItemDB.tablelib = {}

function LibItemDB.tablelib.val_to_str ( v )
	if "string" == type( v ) then
		v = string.gsub( v, "\n", "\\n" )
		if string.match( string.gsub(v,"[^'\"]",""), '^"+$' ) then
			return "'" .. v .. "'"
		end
		return '"' .. string.gsub(v,'"', '\\"' ) .. '"'
	else
		return "table" == type( v ) and LibItemDB.tablelib.tostring( v ) or
			tostring( v )
	end
end

function LibItemDB.tablelib.key_to_str ( k )
	if "string" == type( k ) and string.match( k, "^[_%a][_%a%d]*$" ) then
		return k
	else
		return "[" .. LibItemDB.tablelib.val_to_str( k ) .. "]"
	end
end

function LibItemDB.tablelib.tostring( tbl )
	local result, done = {}, {}
--	for k, v in ipairs( tbl ) do
--		table.insert( result, LibItemDB.tablelib.val_to_str( v ) )
--		done[ k ] = true
--	end
	local maxKey = 0;
	for k, v in pairs( tbl ) do
		if type(k) == "number" and k > maxKey then
			maxKey = k;
		end
	end
		
	for k=1,maxKey do
		if tbl[k] then
			table.insert( result,
				LibItemDB.tablelib.key_to_str( k ) .. "=" .. LibItemDB.tablelib.val_to_str( tbl[k] ) )
			done[ k ] = true
		end
	end
	for k, v in pairs( tbl ) do
		if not done[ k ] then
			table.insert( result,
				LibItemDB.tablelib.key_to_str( k ) .. "=" .. LibItemDB.tablelib.val_to_str( v ) )
		end
	end
	return "{" .. table.concat( result, "," ) .. "}"
end
